
**a DMD GUI for the free electrons !**
![](https://github.com/BBasile/Coedit/raw/master/logo/coedit.png)

Coedit is an IDE for the _DMD_ [D2](http://dlang.org)  compiler.

[![](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.win7.33.png)](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.win7.png)

**Features**
---
- multi platform (_Windows_, _Linux_).
- strictly based on *DMD* (the alternative compilers are not supported).
- comprehensive project format and two advanced project editors (one for the options and configurations, another for the files).
- compile and run directly from the UI.
- single click to compile and execute an unsaved module (aka a _runnable module_).
- single click to compile and _unittest_ a module.
- synchronized edition in a block.
- D2 syntax highlighter, folds, regions, identifier markup.
- symbol list of the module being edited.
- static libraries manager.
- search and replace.
- _todo comments_ analyzer.
- user-defined tools powered by a string interpolation system (in a single click: submit the current module to _dfmt_ or _dscanner_ !)
- full [D Completion Daemon](https://github.com/Hackerpilot/DCD) integration (completion, hints, call tips, jump to symbol declaration).
- mini file browser.
- [selection of 3rd party libraries](https://github.com/BBasile/metad) that can be easily build and integrated to Coedit.

**Project information**
---
- stable version:  version 1 update 2.
- development version: version 2 alpha 1.
- licensed under the term of the MIT license.
- programmed in Object Pascal with [FPC & Lazarus](http://www.lazarus.freepascal.org) as compiler & IDE.

**Build**
---

The procedure is described in the [**first section of the wiki**](https://github.com/BBasile/Coedit/wiki#detailed-setup-procedure)

**GUI preview**
---
Windows version (Windows 7, x86):
![Win screen-cap](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.win7.png "Coedit GUI preview")

Linux version (OpenSuse 13.2, KDE, x86_64):
![Nux screen-cap](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.linux.kde.png "Coedit GUI preview")

Linux version (Mint 17.2, Cinnamon, x86):
![Nux screen-cap](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.linux.cinnamon.png "Coedit GUI preview")
